local f1 = CreateFrame("Frame","PlayerStats",UIParent,"TooltipBorderedFrameTemplate")
local f2 = CreateFrame("Frame","CombatStats",UIParent,"TooltipBorderedFrameTemplate")
local f3 = CreateFrame("Frame","QuestStats",UIParent,"TooltipBorderedFrameTemplate")
local f4 = CreateFrame("Frame","TargetBar",UIParent,"TooltipBorderedFrameTemplate")

local b1 = CreateFrame("Button","TargetMob",UIParent,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b2 = CreateFrame("Button","TargetPlayer",UIParent,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")

local b3 = CreateFrame("Button","pVendor",f4,"TooltipBorderedFrameTemplate")
local b4 = CreateFrame("Button","tStar",f4,"TooltipBorderedFrameTemplate")
local b5 = CreateFrame("Button","tCircle",f4,"TooltipBorderedFrameTemplate")
local b6 = CreateFrame("Button","tDiamond",f4,"TooltipBorderedFrameTemplate")
local b7 = CreateFrame("Button","tTriangle",f4,"TooltipBorderedFrameTemplate")
local b8 = CreateFrame("Button","tMoon",f4,"TooltipBorderedFrameTemplate")
local b9 = CreateFrame("Button","tSquare",f4,"TooltipBorderedFrameTemplate")
local b10 = CreateFrame("Button","tCross",f4,"TooltipBorderedFrameTemplate")
local b11 = CreateFrame("Button","tSkull",f4,"TooltipBorderedFrameTemplate")

local b12 = CreateFrame("Button","tPartyOne",b1,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b13 = CreateFrame("Button","tPartyTwo",b1,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b14 = CreateFrame("Button","tPartyThree",b1,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b15 = CreateFrame("Button","tPartyFour",b1,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")

local t1 = f1:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t2 = f1:CreateFontString(nil,"OVERLAY","GameFontNormal")

local t3 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
local t5 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
local t8 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
local t9 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")

local t6 = f3:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t16 = f3:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t17 = f3:CreateFontString(nil,"OVERLAY","GameFontNormal")

local t10 = b1:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t11 = b1:CreateFontString(nil,"OVERLAY","GameFontNormalHuge")

local t12 = b2:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t13 = b2:CreateFontString(nil,"OVERLAY","GameFontNormalHuge")

local pMissCount = 0
local pSwingAmount, pSwingCount = 0, 0
local pRangeAmount, pRangeCount = 0, 0
local pSpellAmount, pSpellCount = 0, 0
local pDamageAmount, pDamageCount = 0,0

local pHealAmount, pHealCount = 0, 0
local tHealAmount, tHealCount = 0, 0
local sHealAmount, sHealCount = 0, 0

local pGearAmount, pGearCount = 0, 0
local pGearArea, pStatArea = "Gear", "Stats"
local qText, xText, eText = " ", " ", " "

b1:EnableMouse(true)
b1:SetMovable(true)
b1:SetClampedToScreen(true)
b1:RegisterForDrag("RightButton")
b1:SetScript("OnDragStart", function(self, ...)
	if(UnitAffectingCombat("player") == false) then b1:StartMoving() end 
end)
b1:SetScript("OnDragStop", function(self, ...)
	if(UnitAffectingCombat("player") == false) then b1:StopMovingOrSizing() end 
end)
b1:RegisterForClicks("AnyUp")
b1:SetAttribute("type1", "target")
b1:SetAttribute("shift-type1", "macro")
b1:SetAttribute("unit","player")
b1:SetPoint("CENTER",0,-210)
b1:SetSize(320, 80)

t10:SetPoint("TOPLEFT",10, -10)
t10:SetWidth(300)
t10:SetHeight(60)
t10:SetJustifyH("LEFT")
t10:SetTextColor(1,0,0,1)

t11:SetPoint("TOPLEFT",10, -10)
t11:SetWidth(300)
t11:SetHeight(60)
t11:SetJustifyH("RIGHT")
t11:SetTextColor(1,0.5,0.5,1)

b12:SetWidth(50)
b12:SetHeight(50)
b12:EnableMouse(true)
b12:RegisterForClicks("AnyUp")
b12:SetAttribute("type1", "target")
b12:SetAttribute("shift-type1", "macro")
b12:SetAttribute("unit","party1")
b12:SetPoint("TOPLEFT",10,-80)
b12:SetText("1")
b12:SetNormalFontObject("GameFontNormal")

b13:SetWidth(50)
b13:SetHeight(50)
b13:EnableMouse(true)
b13:RegisterForClicks("AnyUp")
b13:SetAttribute("type1", "target")
b13:SetAttribute("shift-type1", "macro")
b13:SetAttribute("unit","party2")
b13:SetPoint("TOPLEFT",80,-80)
b13:SetText("2")
b13:SetNormalFontObject("GameFontNormal")

b14:SetWidth(50)
b14:SetHeight(50)
b14:EnableMouse(true)
b14:RegisterForClicks("AnyUp")
b14:SetAttribute("type1", "target")
b14:SetAttribute("shift-type1", "macro")
b14:SetAttribute("unit","party3")
b14:SetPoint("TOPLEFT",140,-80)
b14:SetText("3")
b14:SetNormalFontObject("GameFontNormal")

b15:SetWidth(50)
b15:SetHeight(50)
b15:EnableMouse(true)
b15:RegisterForClicks("AnyUp")
b15:SetAttribute("type1", "target")
b15:SetAttribute("shift-type1", "macro")
b15:SetAttribute("unit","party4")
b15:SetPoint("TOPLEFT",200,-80)
b15:SetText("4")
b15:SetNormalFontObject("GameFontNormal")

b2:EnableMouse(true)
b2:SetMovable(true)
b2:SetClampedToScreen(true)
b2:RegisterForDrag("RightButton")
b2:SetScript("OnDragStart", function(self, ...)
	if(UnitAffectingCombat("player") == false) then b2:StartMoving() end 
end)
b2:SetScript("OnDragStop", function(self, ...)
	if(UnitAffectingCombat("player") == false) then b2:StopMovingOrSizing() end 
end)
b2:RegisterForClicks("AnyUp")
b2:SetAttribute("type", "macro")
b2:SetAttribute("macrotext", "/cleartarget\n/stopcasting\n/stopattack\n/targetenemy [noexists][dead]\n/startattack")
b2:SetPoint("CENTER",0,210)
b2:SetSize(320, 80)

t12:SetPoint("TOPLEFT",10, -10)
t12:SetWidth(300)
t12:SetHeight(60)
t12:SetJustifyH("LEFT")
t12:SetTextColor(1,0,0,1)

t13:SetPoint("TOPLEFT",10, -10)
t13:SetWidth(300)
t13:SetHeight(60)
t13:SetJustifyH("RIGHT")
t13:SetTextColor(1,0.5,0.5,1)

f1:SetWidth(320)
f1:SetHeight(380)
f1:SetAlpha(.90)
f1:SetPoint("CENTER",-330,0)
f1:SetMovable(true)
f1:EnableMouse(true)
f1:SetClampedToScreen(true)
f1:RegisterForDrag("RightButton")
f1:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f1:RegisterEvent("GROUP_ROSTER_UPDATE")
f1:RegisterEvent("MERCHANT_SHOW")
f1:RegisterEvent("MERCHANT_CLOSED")
f1:RegisterEvent("QUEST_DETAIL")
f1:RegisterEvent("UNIT_HEALTH_FREQUENT")
f1:RegisterEvent("UNIT_POWER_FREQUENT")
f1:RegisterEvent("UNIT_TARGET")
f1:RegisterEvent("UNIT_COMBAT")
f1:SetScript("OnDragStart", f1.StartMoving)
f1:SetScript("OnDragStop", f1.StopMovingOrSizing)
f1:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then f1:Hide() end 
end)
f1:SetScript("OnEvent", function(self, event, ...)
	if(event == "COMBAT_LOG_EVENT_UNFILTERED") then SendStatus(self, CombatLogGetCurrentEventInfo()) ; ShowStats() end
	if(event == "GROUP_ROSTER_UPDATE") then CheckForParty(); end
	if(event == "MERCHANT_SHOW") then f4:Show() ; b3:Show() end
	if(event == "MERCHANT_CLOSED") then b3:Hide() end
	if(event == "QUEST_DETAIL") then AcceptQuest() end
	if(event == "UNIT_HEALTH_FREQUENT") then ShowStats() end
	if(event == "UNIT_POWER_FREQUENT") then ShowStats() end
	if(event == "UNIT_TARGET") then UpdateCombat() ; ShowStats() end
end)

t1:SetPoint("TOPLEFT", 10, -10)
t1:SetWidth(300)
t1:SetHeight(360)
t1:SetJustifyH("LEFT")

t2:SetPoint("TOPLEFT", 10, -10)
t2:SetWidth(300)
t2:SetHeight(360)
t2:SetJustifyH("RIGHT")

f2:SetWidth(320)
f2:SetHeight(260)
f2:SetAlpha(.90)
f2:SetPoint("CENTER",0,0)
f2:SetMovable(true)
f2:EnableMouse(true)
f2:SetClampedToScreen(true)
f2:RegisterForDrag("RightButton")
f2:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then ResetAllAreas() ; CheckForParty() ; end
end)
f2:SetScript("OnDragStart", f2.StartMoving)
f2:SetScript("OnDragStop", f2.StopMovingOrSizing)

t3:SetPoint("TOPLEFT",10, -10)
t3:SetWidth(300)
t3:SetHeight(240)
t3:SetJustifyH("LEFT")

t5:SetPoint("TOPLEFT", 80, -10)
t5:SetWidth(80)
t5:SetHeight(240)
t5:SetJustifyH("RIGHT")

t8:SetPoint("TOPLEFT", 150, -10)
t8:SetWidth(80)
t8:SetHeight(240)
t8:SetJustifyH("RIGHT")

t9:SetPoint("TOPLEFT", 220, -10)
t9:SetWidth(80)
t9:SetHeight(240)
t9:SetJustifyH("RIGHT")

f3:SetWidth(480)
f3:SetHeight(540)
f3:SetAlpha(.90)
f3:SetPoint("CENTER",330,0)
f3:SetMovable(true)
f3:EnableMouse(true)
f3:SetClampedToScreen(true)
f3:RegisterForDrag("RightButton")
f3:SetScript("OnDragStart", f3.StartMoving)
f3:SetScript("OnDragStop", f3.StopMovingOrSizing)
f3:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then f3:Hide() end
end)

t6:SetPoint("TOPLEFT", 10, -10)
t6:SetWidth(240)
t6:SetHeight(520)
t6:SetJustifyH("LEFT")

t16:SetPoint("TOPLEFT", 248, -10)
t16:SetWidth(120)
t16:SetHeight(520)
t16:SetJustifyH("RIGHT")

t17:SetPoint("TOPLEFT", 380, -10)
t17:SetWidth(80)
t17:SetHeight(520)
t17:SetJustifyH("RIGHT")

f4:SetWidth(320)
f4:SetHeight(140)
f4:SetAlpha(.90)
f4:SetPoint("CENTER",0,-170)
f4:EnableMouse(true)
f4:SetMovable(true)
f4:SetClampedToScreen(true)
f4:RegisterForDrag("RightButton")
f4:SetScript("OnDragStart", f4.StartMoving)
f4:SetScript("OnDragStop", f4.StopMovingOrSizing)
f4:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then f4:Hide() end 
end)

b3:SetWidth(50)
b3:SetHeight(50)
b3:SetPoint("TOPLEFT",250,-80)
b3:EnableMouse(true)
b3:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then VendorGray(); end
end)
b3:SetText("Vendor\nGray\nItems")
b3:SetNormalFontObject("GameFontNormalTiny")

b4:SetWidth(50)
b4:SetHeight(50)
b4:SetPoint("TOPLEFT",10,-20)
b4:EnableMouse(true)
b4:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 1); end
end)
b4:SetText("1")
b4:SetNormalFontObject("GameFontNormalHuge")

b5:SetWidth(50)
b5:SetHeight(50)
b5:SetPoint("TOPLEFT",70,-20)
b5:EnableMouse(true)
b5:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 2); end
end)
b5:SetText("2")
b5:SetNormalFontObject("GameFontNormalHuge")

b6:SetWidth(50)
b6:SetHeight(50)
b6:SetPoint("TOPLEFT",130,-20)
b6:EnableMouse(true)
b6:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 3); end
end)
b6:SetText("3")
b6:SetNormalFontObject("GameFontNormalHuge")

b7:SetWidth(50)
b7:SetHeight(50)
b7:SetPoint("TOPLEFT",190,-20)
b7:EnableMouse(true)
b7:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 4); end
end)
b7:SetText("4")
b7:SetNormalFontObject("GameFontNormalHuge")

b8:SetWidth(50)
b8:SetHeight(50)
b8:SetPoint("TOPLEFT",250,-20)
b8:EnableMouse(true)
b8:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 5); end
end)
b8:SetText("5")
b8:SetNormalFontObject("GameFontNormalHuge")

b9:SetWidth(50)
b9:SetHeight(50)
b9:SetPoint("TOPLEFT",10,-80)
b9:EnableMouse(true)
b9:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 6); end
end)
b9:SetText("6")
b9:SetNormalFontObject("GameFontNormalHuge")

b10:SetWidth(50)
b10:SetHeight(50)
b10:SetPoint("TOPLEFT",70,-80)
b10:EnableMouse(true)
b10:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 7); end
end)
b10:SetText("7")
b10:SetNormalFontObject("GameFontNormalHuge")

b11:SetWidth(50)
b11:SetHeight(50)
b11:SetPoint("TOPLEFT",130,-80)
b11:EnableMouse(true)
b11:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 8); end
end)
b11:SetText("8")
b11:SetNormalFontObject("GameFontNormalHuge")

Minimap:SetScale(1.7)
Minimap:ClearAllPoints()
Minimap:SetMovable(true)
Minimap:EnableMouse(true)
Minimap:EnableMouseWheel(true)
Minimap:RegisterForDrag("RightButton")
Minimap:SetClampedToScreen(true)
Minimap:SetScript("OnDragStart", Minimap.StartMoving)
Minimap:SetScript("OnDragStop", Minimap.StopMovingOrSizing)
Minimap:SetUserPlaced(true)
Minimap:SetPoint("TOPRIGHT", -20, -5)
Minimap:SetScript("OnMouseWheel", function(self, direction)
	local zoom, maxZoom = Minimap:GetZoom() + direction, Minimap:GetZoomLevels()
	if(zoom >= maxZoom) then zoom = maxZoom end
	if(zoom <= 0) then zoom = 0 end
	Minimap:SetZoom(zoom)
end)
Minimap:SetMaskTexture("Interface\\Buttons\\WHITE8X8")

MinimapBorder:Hide()
GameTimeFrame:Hide()

MinimapBackdrop:SetBackdrop({
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = true, tileSize = 16, edgeSize = 16,
	insets = {left = 3, right = 3, top = 3, bottom = 3} })
MinimapBackdrop:ClearAllPoints()
MinimapBackdrop:SetBackdropColor(0, 0, 0, 0.5)
MinimapBackdrop:SetBackdropBorderColor(0.75, 0.75, 0.75)
MinimapBackdrop:SetAlpha(1)
MinimapBackdrop:SetPoint("TOPLEFT", Minimap, "TOPLEFT", -4, 4)
MinimapBackdrop:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", 4, -4)

MinimapNorthTag:SetTexture()

MinimapZoneTextButton:ClearAllPoints()
MinimapZoneTextButton:SetPoint("CENTER", Minimap, "BOTTOM", 0, 10)
MinimapZoneTextButton:SetScale(1)
MinimapZoneTextButton:SetFrameStrata("HIGH")

MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetPoint("TOPLEFT", Minimap, -16, 10)
MiniMapMailFrame:SetScale(1)
MiniMapMailFrame:SetFrameStrata("HIGH")

MiniMapTrackingFrame:ClearAllPoints()
MiniMapTrackingFrame:SetPoint("TOPLEFT", Minimap, 88, 10)
MiniMapTrackingFrame:SetScale(1)
MiniMapTrackingFrame:SetFrameStrata("HIGH")

MinimapZoomIn:ClearAllPoints()
MinimapZoomIn:SetPoint("TOPLEFT", Minimap, 16, 10)
MinimapZoomIn:SetScale(1)
MinimapZoomIn:SetFrameStrata("HIGH")

MinimapZoomOut:ClearAllPoints()
MinimapZoomOut:SetPoint("TOPLEFT", Minimap, 52, 10)
MinimapZoomOut:SetScale(1)
MinimapZoomOut:SetFrameStrata("HIGH")

WorldMapFrame:SetMovable(true)
WorldMapFrame:EnableMouse(true)
WorldMapFrame:SetScale(0.7)
WorldMapFrame:SetClampedToScreen(true)
WorldMapFrame:RegisterForDrag("RightButton")
WorldMapFrame:SetScript("OnDragStart", WorldMapFrame.StartMoving)
WorldMapFrame:SetScript("OnDragStop", WorldMapFrame.StopMovingOrSizing)

WorldMapFrame.BlackoutFrame:EnableMouse(false)
WorldMapFrame.BlackoutFrame.Blackout:SetAlpha(0)

MainMenuBarLeftEndCap:Hide()
MainMenuBarRightEndCap:Hide()

f1:Hide() ; f2:Show() ; f3:Hide() ; f4:Hide()
b1:Show() ; b2:Show() ; b3:Hide()
b12:Hide() ; b13:Hide() ; b14:Hide() ; b15:Hide()

function ResetAllAreas()
	pMissCount = 0
	pSwingAmount, pSwingCount = 0, 0
	pRangeAmount, pRangeCount = 0, 0
	pSpellAmount, pSpellCount = 0, 0
	pDamageAmount, pDamageCount = 0,0

	pHealAmount, pHealCount = 0, 0
	tHealAmount, tHealCount = 0, 0
	sHealAmount, sHealCount = 0, 0

	pGearAmount, pGearCount = 0, 0
	pGearArea, pStatArea = "Gear", "Stats"

	if(MerchantFrame:IsVisible() == false) then b3:Hide() end
	if(f1:IsVisible() == false) then f1:Show() end
	if(f3:IsVisible() == false) then f3:Show() end
	if(f4:IsVisible() == false) then f4:Show() end
end

function CheckForParty()
	local isCombat = UnitAffectingCombat("player")
	if(isCombat == false) then
		local pGroupNum = GetNumGroupMembers()
		if(pGroupNum > 1) then 
			b1:SetSize(320, 140)
			if(b12:IsVisible() == false) then b12:Show(); end
			local p1Health = UnitHealth("party1")
			local p1Mana = UnitPower("party1")
			local p1ManaMax = UnitPowerMax("party1")
			local p1HeathMax = UnitHealthMax("party1")
			local pv1Text = format("%3d", ((p1Health / p1HeathMax) * 100)) .. "\n" .. format("%3d", ((p1Mana / p1ManaMax) * 100))
			b12:SetText(pv1Text)
		end
		if(pGroupNum > 2) then 
			if(b13:IsVisible() == false) then b13:Show(); end
			local p2Health = UnitHealth("party2")
			local p2Mana = UnitPower("party2")
			local p2ManaMax = UnitPowerMax("party2")
			local p2HeathMax = UnitHealthMax("party2")
			local pv2Text = format("%3d", ((p2Health / p2HeathMax) * 100)) .. "\n" .. format("%3d", ((p2Mana / p2ManaMax) * 100))
			b13:SetText(pv2Text)
		end
		if(pGroupNum > 3) then 
			if(b14:IsVisible() == false) then b14:Show(); end
			local p3Health = UnitHealth("party3")
			local p3Mana = UnitPower("party3")
			local p3ManaMax = UnitPowerMax("party3")
			local p3HeathMax = UnitHealthMax("party3")
			local pv3Text = format("%3d", ((p3Health / p3HeathMax) * 100)) .. "\n" .. format("%3d", ((p3Mana / p3ManaMax) * 100))
			b14:SetText(pv3Text)
		end
		if(pGroupNum > 4) then 
			if(b15:IsVisible() == false) then b15:Show(); end
			local p4Health = UnitHealth("party4")
			local p4Mana = UnitPower("party4")
			local p4ManaMax = UnitPowerMax("party4")
			local p4HeathMax = UnitHealthMax("party4")
			local pv4Text = format("%3d", ((p4Health / p4HeathMax) * 100)) .. "\n" .. format("%3d", ((p4Mana / p4ManaMax) * 100))
			b15:SetText(pv4Text)
		end
		if(pGroupNum < 2) then 
			b1:SetSize(320, 80)
			if(b12:IsVisible() == true) then b12:Hide(); end
			if(b13:IsVisible() == true) then b13:Hide(); end
			if(b14:IsVisible() == true) then b14:Hide(); end
			if(b15:IsVisible() == true) then b15:Hide(); end
		end
	end
end

function UpdateClassSpells()
	local isCombat = UnitAffectingCombat("player")
	local _, _, classID = UnitClass("player")
	if(isCombat == false) then
		if(classID == 2) then
			b1:SetAttribute("macrotext", "/target player\n/cast Blessing of Wisdom")
			b12:SetAttribute("macrotext", "/target party1\n/cast Blessing of Wisdom")
			b13:SetAttribute("macrotext", "/target party2\n/cast Blessing of Wisdom")
			b14:SetAttribute("macrotext", "/target party3\n/cast Blessing of Wisdom")
			b15:SetAttribute("macrotext", "/target party4\n/cast Blessing of Wisdom")
		end
		if(classID == 5) then
			b1:SetAttribute("macrotext", "/target player\n/cast Power Word: Fortitude")
			b12:SetAttribute("macrotext", "/target party1\n/cast Power Word: Fortitude")
			b13:SetAttribute("macrotext", "/target party2\n/cast Power Word: Fortitude")
			b14:SetAttribute("macrotext", "/target party3\n/cast Power Word: Fortitude")
			b15:SetAttribute("macrotext", "/target party4\n/cast Power Word: Fortitude")
		end
		if(classID == 8) then
			b1:SetAttribute("macrotext", "/target player\n/cast Arcane Intellect")
			b12:SetAttribute("macrotext", "/target party1\n/cast Arcane Intellect")
			b13:SetAttribute("macrotext", "/target party2\n/cast Arcane Intellect")
			b14:SetAttribute("macrotext", "/target party3\n/cast Arcane Intellect")
			b15:SetAttribute("macrotext", "/target party4\n/cast Arcane Intellect")
		end
		if(classID == 11) then
			b1:SetAttribute("macrotext", "/target player\n/cast Mark of the Wild")
			b12:SetAttribute("macrotext", "/target party1\n/cast Mark of the Wild")
			b13:SetAttribute("macrotext", "/target party2\n/cast Mark of the Wild")
			b14:SetAttribute("macrotext", "/target party3\n/cast Mark of the Wild")
			b15:SetAttribute("macrotext", "/target party4\n/cast Mark of the Wild")
		end
	end
end

function VendorGray()
	local i,j,xSold = 0,0,0
	repeat
		local gSlots = GetContainerNumSlots(i)
		if(gSlots ~= nil) then
			j = 1
			repeat
				local gItemLink = GetContainerItemLink(i, j)
				if(gItemLink ~= nil) then
					local _,_,gQuality = GetItemInfo(gItemLink)
					if(gQuality ~= nil) then
						if(gQuality == 0) then UseContainerItem(i,j) ; xSold = xSold + 1 end
					end
				end
				j = j + 1
			until(j > gSlots)
		end
		i = i + 1
	until(i > 4)
	DEFAULT_CHAT_FRAME:AddMessage("Sold " .. xSold .. " gray items.")
end

function SendStatus(self, ...)
	local playerUsed = UnitGUID("player")
	local targetUsed = UnitGUID("target")
	local _, eventtype, _, sourceGUID, _, _, _, destGUID, _, _, _ = ...
	if(sourceGUID == playerUsed) then
		if(eventtype == "SWING_DAMAGE") then
			local amount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pSwingCount = pSwingCount + 1 ; pSwingAmount = pSwingAmount + amount
		end
		if(eventtype == "SPELL_DAMAGE") then
			local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pSpellCount = pSpellCount + 1 ; pSpellAmount = pSpellAmount + spellamount
		end
		if(eventtype == "SPELL_PERIODIC_DAMAGE") then
			local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pSpellCount = pSpellCount + 1 ; pSpellAmount = pSpellAmount + spellamount
		end
		if(eventtype == "RANGE_DAMAGE") then
			local _, _, _, rangeamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pRangeCount = pRangeCount + 1 ; pRangeAmount = pRangeAmount + rangeamount
		end

		if(eventtype == "SWING_MISSED") then pMissCount = pMissCount + 1 end
		if(eventtype == "SPELL_MISSED") then pMissCount = pMissCount + 1 end
		if(eventtype == "RANGE_MISSED") then pMissCount = pMissCount + 1 end

		if(destGUID == playerUsed) then
			if(eventtype == "SPELL_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pHealCount = pHealCount + 1 ; pHealAmount = pHealAmount + spellamount
			end
			if(eventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pHealCount = pHealCount + 1 ; pHealAmount = pHealAmount + spellamount
			end
		end
		if(destGUID ~= playerUsed) then
			if(eventtype == "SPELL_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				tHealCount = tHealCount + 1 ; tHealAmount = tHealAmount + spellamount
			end
			if(eventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				tHealCount = tHealCount + 1 ; tHealAmount = tHealAmount + spellamount
			end
		end
	end
	if(sourceGUID ~= playerUsed) then
		if(destGUID == playerUsed) then
			if(eventtype == "SWING_DAMAGE") then
				local amount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + amount
			end
			if(eventtype == "SPELL_DAMAGE") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + spellamount
			end
			if(eventtype == "SPELL_PERIODIC_DAMAGE") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + spellamount
			end
			if(eventtype == "RANGE_DAMAGE") then
				local _, _, _, rangeamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + rangeamount
			end

			if(eventtype == "SWING_MISSED") then pDamageCount = pDamageCount + 1 end
			if(eventtype == "SPELL_MISSED") then pDamageCount = pDamageCount + 1 end
			if(eventtype == "RANGE_MISSED") then pDamageCount = pDamageCount + 1 end

			if(eventtype == "SPELL_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sHealCount = sHealCount + 1 ; sHealAmount = sHealAmount + spellamount
			end
			if(eventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sHealCount = sHealCount + 1 ; sHealAmount = sHealAmount + spellamount
			end
		end
	end
end

function UpdateGearView(self, gearName, gearLevel)
	local gearStat = 0
	if(gearLevel == nil) then gearStat = 0 end
	if(gearLevel ~= nil) then gearStat = gearLevel end
	pGearArea = pGearArea .. "\n" .. gearName
	pStatArea = pStatArea .. "\n" .. gearStat
	pGearCount = pGearCount + 1
	pGearAmount = pGearAmount + gearStat
end

function UpdateMainHand()
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("MainHandSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Main Hand", wLvl) end
end

function UpdateSecondary() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("SecondaryHandSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Off Hand", wLvl) end
end

function UpdateHead() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("HeadSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Head", wLvl) end
end

function UpdateNeck() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("NeckSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Neck", wLvl) end
end

function UpdateShoulder() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("ShoulderSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Shoulder", wLvl) end
end

function UpdateBack() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("BackSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Back", wLvl) end
end

function UpdateChest() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("ChestSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Chest", wLvl) end
end

function UpdateWrist() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("WristSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Wrist", wLvl) end
end

function UpdateHands() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("HandsSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Hands", wLvl) end
end

function UpdateWaist() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("WaistSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Waist", wLvl) end
end

function UpdateLegs() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("LegsSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Legs", wLvl) end
end

function UpdateFeet() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("FeetSlot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Feet", wLvl) end
end

function UpdateFingerOne() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("Finger0Slot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Finger", wLvl) end
end

function UpdateFingerTwo() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("Finger1Slot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Finger", wLvl) end
end

function UpdateTrinketOne() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("Trinket0Slot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Trinket", wLvl) end
end

function UpdateTrinketTwo() 
	itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("Trinket1Slot"))
	if(itemLink ~= nil) then local _, _, _, wLvl = GetItemInfo(itemLink) ; UpdateGearView(self, "Trinket", wLvl) end
end

function UpdateGear()
	pGearCount, pGearAmount = 0, 0
	pGearArea, pStatArea = " ", " "
	UpdateMainHand() ; UpdateSecondary() ; UpdateHead() ; UpdateNeck()
	UpdateBack() ; UpdateShoulder(); UpdateChest() ; UpdateWrist()
	UpdateHands() ;  UpdateWaist() ; UpdateLegs() ; UpdateFeet()
	UpdateFingerOne() ; UpdateFingerTwo() ; UpdateTrinketOne() ; UpdateTrinketTwo()
	pGearArea = pGearArea .. "\n" .. "Equipped"
	if(pGearCount > 0) then pStatArea = pStatArea .. "\n" .. format("%.0f", (pGearAmount / pGearCount)) end
end

function UpdateStats()
	local pCrit = format("%.2f%%", GetCritChance())
	local sCrit = format("%.2f%%", GetSpellCritChance())
	local rCrit = format("%.2f%%", GetRangedCritChance())
	local pHit, base = GetManaRegen()
	local cSpeed, rSpeed, fSpeed, sSpeed = GetUnitSpeed("player")
	local bPwr, pPwr, nPwr = UnitAttackPower("player")
	local rbPwr, rpPwr, rnPwr = UnitRangedAttackPower("player")
	local ePwr = bPwr + pPwr + nPwr
	local rePwr = rbPwr + rpPwr + rnPwr
	local saText = "Attack\nRanged\n\nMelee Crit\nSpell Crit\nRanged Crit\n\nMana Regen\nCombat Regen\nMove Speed\n" .. pGearArea
	local sbText = ePwr .. "\n" .. rePwr .. "\n\n" .. pCrit .. "\n" .. sCrit .. "\n" .. rCrit .. "\n\n" .. format("%.2f", (base * 2)) .. "\n" .. format("%.2f", (pHit * 2)) .. "\n" .. format("%.0f", cSpeed) .. "\n" .. pStatArea
	t1:SetText(saText) ; t2:SetText(sbText)
end

function UpdatePlayer()
	local pName = UnitName("player")
	if(pName ~= nil) then
		local pHealth = UnitHealth("player")
		local pMana = UnitPower("player")
		local pText = pName .. "\n\n" .. "Power"
		local pvText = pHealth .. "\n" .. pMana
		t10:SetText(pText)
		t11:SetText(pvText)
	end
end

function UpdateTarget()
	local mName = UnitName("target")
	if(mName ~= nil) then
		local mHealth = UnitHealth("target")
		local mMana = UnitPower("target")
		local tText = mName .. "\n\n" .. "Power"
		local tvText = mHealth .. "\n" .. mMana
		t12:SetText(tText)
		t13:SetText(tvText)
	end
end

function UpdateCombat()	
	local pTotalAvg, pSwingAvg, pRangeAvg, pSpellAvg = 0, 0, 0, 0
	local pDamageAvg, pHealAvg, tHealAvg, sHealAvg, pHealTotalAvg = 0, 0, 0, 0, 0

	local pTotalAmount = pSpellAmount + pSwingAmount + pRangeAmount
	local pTotalCount = pSpellCount + pSwingCount + pRangeCount + pMissCount

	local pHealTotalAmount = pHealAmount + tHealAmount + sHealAmount
	local pHealTotalCount = pHealCount + tHealCount + sHealCount
	
	local vText = " \nMissed\nSwing\nSpell\nRange\nAttacks\n\nHealed\nHealing\nHealers\nHeals\n\nDamage"
	local lText = format("%8s", "Hits")
	local kText = format("%8s", "Avg")
	local gText = format("%8s", "Total")
	
	if(pSwingCount > 0) then pSwingAvg = (pSwingAmount / pSwingCount); end
	if(pRangeCount > 0) then pRangeAvg = (pRangeAmount / pRangeCount); end
	if(pSpellCount > 0) then pSpellAvg = (pSpellAmount / pSpellCount); end
	if(pTotalCount > 0) then pTotalAvg = (pTotalAmount / pTotalCount); end

	if(pHealCount > 0) then pHealAvg = (pHealAmount / pHealCount); end
	if(tHealCount > 0) then tHealAvg = (tHealAmount / tHealCount); end
	if(sHealCount > 0) then sHealAvg = (sHealAmount / sHealCount); end
	if(pHealTotalCount > 0) then pHealTotalAvg = (pHealTotalAmount / pHealTotalCount); end

	if(pDamageCount > 0) then pDamageAvg = pDamageAmount / pDamageCount end

	lText = lText .. "\n" .. format("%8d", pMissCount)
	lText = lText .. "\n" .. format("%8d", pSwingCount)
	lText = lText .. "\n" .. format("%8d", pSpellCount)
	lText = lText .. "\n" .. format("%8d", pRangeCount)
	lText = lText .. "\n" .. format("%8d", pTotalCount)

	lText = lText .. "\n"
	lText = lText .. "\n" .. format("%8d", pHealCount)
	lText = lText .. "\n" .. format("%8d", tHealCount)
	lText = lText .. "\n" .. format("%8d", sHealCount)
	lText = lText .. "\n" .. format("%8d", pHealTotalCount)

	lText = lText .. "\n"
	lText = lText .. "\n" .. format("%8d", pDamageCount)

	kText = kText .. "\n"
	kText = kText .. "\n" .. format("%8d", pSwingAvg)
	kText = kText .. "\n" .. format("%8d", pSpellAvg)
	kText = kText .. "\n" .. format("%8d", pRangeAvg)
	kText = kText .. "\n" .. format("%8d", pTotalAvg)

	kText = kText .. "\n"
	kText = kText .. "\n" .. format("%8d", pHealAvg)
	kText = kText .. "\n" .. format("%8d", tHealAvg)
	kText = kText .. "\n" .. format("%8d", sHealAvg)
	kText = kText .. "\n" .. format("%8d", pHealTotalAvg)

	kText = kText .. "\n"
	kText = kText .. "\n" .. format("%8d", pDamageAvg)

	gText = gText .. "\n"
	gText = gText .. "\n" .. format("%8d", pSwingAmount)
	gText = gText .. "\n" .. format("%8d", pSpellAmount)
	gText = gText .. "\n" .. format("%8d", pRangeAmount)
	gText = gText .. "\n" .. format("%8d", pTotalAmount)

	gText = gText .. "\n"
	gText = gText .. "\n" .. format("%8d", pHealAmount)
	gText = gText .. "\n" .. format("%8d", tHealAmount)
	gText = gText .. "\n" .. format("%8d", sHealAmount)
	gText = gText .. "\n" .. format("%8d", pHealTotalAmount)

	gText = gText .. "\n"
	gText = gText .. "\n" .. format("%8d", pDamageAmount)

	t3:SetText(vText)
	t5:SetText(lText)
	t8:SetText(kText)
	t9:SetText(gText)
end

function UpdateZoneText(tZone, lZone, MZone)
	qText = qText .. "\n" .. tZone
	xText = xText .. "\n" .. lZone
	eText = eText .. "\n" .. MZone
end

function UpdateExperience()
	local pLvl = UnitLevel("player")
	local pExp = UnitXP("player")
	local pExpMax = UnitXPMax("player")
	local tExp = pExpMax - pExp
	local pXPLvl = ((pLvl * 5) + 45)
	local tExpCount = tExp / pXPLvl
	qText = ""
    	xText = ""
    	eText = ""
	UpdateZoneText("NPC Level " .. pLvl .. " (" .. pXPLvl .. " xp)\nExperience\n","\n\n",format("%.0f", tExpCount) .. "\n" .. tExp .. "\n")
end

function UpdateZone()
	local pLvl = UnitLevel("player")
	UpdateZoneText("Zone\n","Lvl\n","Max\n")
	
	if(pLvl < 10) then 
		UpdateZoneText("Dun Morogh","1","10")
		UpdateZoneText("Durotar","1","10")
		UpdateZoneText("Elwynn Forest","1","10")
		UpdateZoneText("Mulgore","1","10")
		UpdateZoneText("Teldrassil","1","10")
		UpdateZoneText("Tirisfal Glades","1","10")
	end

	if(pLvl > 9) then
		if(pLvl < 21) then
			UpdateZoneText("Darkshore","10","20")
			UpdateZoneText("Loch Modan","10","20")
			UpdateZoneText("Silverpine Forest","10","20")
			UpdateZoneText("Westfall","10","20")
		end
	end

	if(pLvl > 14) then
		if(pLvl < 26) then UpdateZoneText("Redridge Mountains","15","25") end
		if(pLvl < 28) then UpdateZoneText("Stonetalon Mountains","15","27") end
	end

	if(pLvl > 17) then
		if(pLvl < 31) then UpdateZoneText("Ashenvale","18","30") end
		if(pLvl < 31) then UpdateZoneText("Duskwood","18","30") end
	end

	if(pLvl > 19) then
		if(pLvl < 31) then UpdateZoneText("Hillsbrad Foothills","20","30") end
		if(pLvl < 31) then UpdateZoneText("Wetlands","20","30") end
	end

	if(pLvl > 24) then
		if(pLvl < 36) then UpdateZoneText("Thousand Needles","25","35") end
	end

	if(pLvl > 29) then
		if(pLvl < 46) then UpdateZoneText("Stranglethorn Vale","30","45") end
	end

	if(pLvl > 34) then
		if(pLvl < 46) then UpdateZoneText("Duskwallow Marsh","35","45") end
		if(pLvl < 46) then UpdateZoneText("Badlands","35","45") end 
		if(pLvl < 46) then UpdateZoneText("Swamp of Sorrows","35","45") end 
	end

	if(pLvl > 29) then
		if(pLvl < 41) then UpdateZoneText("Alterac Mountains","30","40") end
		if(pLvl < 41) then UpdateZoneText("Arathi Highlands","30","40") end
		if(pLvl < 41) then UpdateZoneText("Desolace","30","40") end
	end

	if(pLvl > 39) then
		if(pLvl < 51) then UpdateZoneText("Feralas","40","50") end 
		if(pLvl < 51) then UpdateZoneText("Hinterlands","40","50") end
		if(pLvl < 51) then UpdateZoneText("Tanaris","40","50") end
	end

	if(pLvl > 44) then 
		if(pLvl < 51) then UpdateZoneText("Searing Gorge","45","50") end
		if(pLvl < 56) then UpdateZoneText("Azshara","45","55") end
		if(pLvl < 56) then UpdateZoneText("Blasted Lands","45","55") end
	end

	if(pLvl > 47) then 
		if(pLvl < 56) then UpdateZoneText("Un'goro Crater","48","55") end
		if(pLvl < 56) then UpdateZoneText("Felwood","48","55") end
	end

	if(pLvl > 49) then 
		if(pLvl < 59) then UpdateZoneText("Burning Steppes","50","58") end
	end

	if(pLvl > 50) then 
		if(pLvl < 59) then UpdateZoneText("Western Plaguelands","51","58") end
	end

	if(pLvl > 52) then
		if(pLvl < 61) then UpdateZoneText("Eastern Plaguelands","53","60") end
		if(pLvl < 61) then UpdateZoneText("Winterspring","53","60") end
	end

	if(pLvl > 58) then
		if(pLvl < 61) then UpdateZoneText("Deadwind Pass","59","60") end
		if(pLvl < 61) then UpdateZoneText("Moonglade","59","60") end
		if(pLvl < 61) then UpdateZoneText("Silithus","59","60") end
	end
end

function UpdateDungeon()
	local dLvl = UnitLevel("player")
	UpdateZoneText("\nDungeon\n","\nLvl\n","\nBoss\n")

	if(dLvl > 12) then
		if(dLvl < 19) then UpdateZoneText("Ragefire Chasm RFC","13","16") end
	end

	if(dLvl > 17) then
		if(dLvl < 24) then UpdateZoneText("The Deadmines VC","18","21") end
        	if(dLvl < 25) then UpdateZoneText("Wailing Caverns WC","18","22") end
        	if(dLvl < 29) then UpdateZoneText("Shadowfang Keep SFK","18","26") end
	end

	if(dLvl > 23) then
		if(dLvl < 31) then UpdateZoneText("Blackfathom Deeps BFD","24","28") end
	end
    
	if(dLvl > 22) then
		if(dLvl < 32) then UpdateZoneText("The Stockade STOCKS","23","29") end
        	if(dLvl < 37) then UpdateZoneText("Gnomeregan GNOMER","23","34") end
	end
    
	if(dLvl > 28) then
		if(dLvl < 36) then UpdateZoneText("Razorfen Kraul RFK","29","33") end
	end
    
	if(dLvl > 29) then
		if(dLvl < 37) then UpdateZoneText("Scarlet Monastery Graveyard SMgy","30","34") end
        	if(dLvl < 37) then UpdateZoneText("Scarlet Monastery Library SMlib","30","34") end
	end
    
	if(dLvl > 36) then
		if(dLvl < 43) then UpdateZoneText("Scarlet Monastery Armory SMArms","30","39") end
	end
    
	if(dLvl > 34) then
		if(dLvl < 45) then UpdateZoneText("Scarlet Monastery Cathedral SMCath","35","42") end
	end
    
	if(dLvl > 36) then
		if(dLvl < 44) then UpdateZoneText("Razorfen Downs RFD","37","41") end
	end
    
	if(dLvl > 40) then
		if(dLvl < 50) then UpdateZoneText("Uldaman ULDA","41","47") end
	end
    
	if(dLvl > 43) then
		if(dLvl < 51) then UpdateZoneText("Zul'Farrak ZF","44","48") end
	end
    
	if(dLvl > 45) then
		if(dLvl < 53) then UpdateZoneText("Maraudon MARA","46","51") end
	end
    
	if(dLvl > 49) then
		if(dLvl < 58) then UpdateZoneText("Temple of Atal'Hakkar ST","50","55") end
	end
    
	if(dLvl > 48) then
		if(dLvl < 61) then UpdateZoneText("Blackrock Depths BRD","49","59") end
	end
    
	if(dLvl > 55) then 
		if(dLvl < 61) then UpdateZoneText("Lower Blackrock Spire LBRS","56","60") end
	end
    
	if(dLvl > 54) then 
		if(dLvl < 61) then UpdateZoneText("Diremaul DM","37","41") end
		if(dLvl < 61) then UpdateZoneText("Upper Blackrock Spire UBRS Raid 10","55","62") end
	end
    
	if(dLvl > 57) then 
		if(dLvl < 61) then UpdateZoneText("Stratholme STRAT","58","62") end
		if(dLvl < 61) then UpdateZoneText("Scholomance SCHOLO","58","62") end
	end
end

function UpdateQuestInfo()
	local tGold = 0
	local nEntries, nQuests = GetNumQuestLogEntries()
	UpdateZoneText("\nQuests\n","\nGold\n","\nLevel\n")
	for i=1, nEntries do
		local qTitle, qLevel, _, qHeader, _, _, _, qID, _, _, _, _, _, _, _, _, _, _ = GetQuestLogTitle(i)
		if(qHeader == false) then
			local qMoney = GetQuestLogRewardMoney(qID)
			UpdateZoneText(qTitle,format("%.4f", (qMoney / 10000)),qLevel)
			tGold = tGold + qMoney
		end
	end
	UpdateZoneText("Total Gold",format("%.4f", (tGold / 10000))," ")
end

function ShowStats()
	UpdateExperience()
	UpdateGear()
	UpdateStats()
	UpdatePlayer()
	UpdateTarget()
	UpdateCombat()
	UpdateZone()
	UpdateDungeon()
	UpdateQuestInfo()
	t6:SetText(qText)
	t16:SetText(xText)
	t17:SetText(eText)
end

CheckForParty()
UpdateClassSpells()



